//  File Ty_Dncr_31_BT_Defines.h
//  Path ..\NXT\Projects\Tiny_Dancers\Shared_Files\Ty_Dncr_31_BT_Defines.h
//  Created by: hdrake, TabbyCat Robots      2012Dec20

#ifndef _TY_DNCR_BT_DEFINES_H
#define _TY_DNCR_BT_DEFINES_H

//  *******************************
//  #defines
//  *******************************

#define BT_CONNECTION_SUCCESS      1

#define BT_PRI_CONN              0


#define BT_OPERATION_INCOMPLETE    0xff
#define BT_CONNECTION_SUCCESS         1
#define BT_CONN_ERROR                16
#define BT_MISC_STATUS_ERROR         99

#define INIT_BT_MSG_01          0x1f
#define INIT_BT_MSG_02          0x01ff
#define INIT_BT_MSG_03          0x02f
#define INIT_BT_MSG_04          0x02ff

#define BT_CONN_00              0
#define BT_CONN_01              1
#define BT_CONN_02              2
#define BT_CONN_03              3

//  For square dance routines.
#define LDR_BT_CONN              BT_CONN_00
#define LDRS_RT_BT_CONN          BT_CONN_01
#define LDRS_OPP_BT_CONN         BT_CONN_02
#define LDRS_LFT_BT_CONN         BT_CONN_03

/*******************************************************************************
/*  For a Conga Line routine, or some other line dance, we may want
/*  the leader first in line or last.  So we might have one of the following
/*  two sets of #defines.  Remember, the leader is always the BT master.
/*
/*  #define 1ST_IN_LINE_BT_CONN   BT_CONN_01  //  Dncr using conn 1 is 1st in line
/*  #define 2ND_IN_LINE_BT_CONN   BT_CONN_02
/*  #define 3RD_IN_LINE_BT_CONN   BT_CONN_03
/*  #define LDR_BT_CONN           BT_CONN_00  //  Leader is last in line.
/*
/*  #define LDR_BT_CONN           BT_CONN_00  //  Leader is first in line.
/*  #define 2ND_IN_LINE_BT_CONN   BT_CONN_01  //  Dncr using conn 1 is 2nd in line
/*  #define 3RD_IN_LINE_BT_CONN   BT_CONN_02
/*  #define 4TH_IN_LINE_BT_CONN   BT_CONN_03
/*
/******************************************************************************/

//  For all routines
//  The leaders dncr_pri_bt_queue will always be LDR_BT_Q.
#define LDR_BT_Q                 0

//  The following _BT_Q #defines may be a dancer's dncr_pri_bt_queue,
//  dncr_sec_bt_queue, or dncr_tert_bt_queue.
#define FREE_SPIRIT_BT_Q         9

#define BT_Q_NOT_DEFINED        99

//  For square dance routines, dancer's BT queue.
#define LDRS_RT_BT_Q             1
#define LDRS_OPP_BT_Q            2
#define LDRS_LFT_BT_Q            3

//  For line dance routines, dancer's BT queue.
//  Remember, the leader knows the routine, and thus whether the other 3 dancers
//  are 1st, 2nd, 3rd in line, or 2nd, 3rd, and 4th.  Note that this must be
//  correctly set when initializing the array dncr_rtine_info[].
#define FRST_IN_LINE_BT_Q             1
#define SCND_IN_LINE_BT_Q             2
#define THRD_IN_LINE_BT_Q             3
#define FRTH_IN_LINE_BT_Q             4

#define DO_IT_SEND_TIME             100

//  BlueTooth message stubs
//  BlueTooth messages will be unsigned long (after those sent during initial
//  setup of the BT channel.)
//  All messages will have a message ID (serial number), that are the last 2
//  hex digits, i.e. 0xmmmmmmid.  So unique IDs are 0x00 thru 0xff.  IDs will
//  monotonically increase, and roll over from 255 to 0.  IDs are on a per
//  queue basis.  The LDR and Sprt NXTs will initiallize last_good_rcvd_msg_id
//  for all queues to 0xff, and next_msg_to_send_id to 0x00.
//
//  Initiated messages, usually commands from the LDR, will begin with 0x11 thru
//  0x3f.  The next 4 hex digits are for data.  Thus there are 31 unique
//  commands plus many variations, using the 4 data bits.
//
//  If the leader needs to resend a command, it will increment the first hex
//  digit by 0x4, so the commands become 0x51 to 0x7f.  The last msg ID will be
//  reused.
//
//  If the leader doesn't want to resend a command, but wants to move on to
//  something new, it will increment the first hex digit by 0x8.  The next msg
//  ID will be used.  Upon a message of this type, i.e. beginning with 0x91
//  thru 0xbf, the receiver will not NACK due to msg ID not being exactly one
//  greater than last_good_rcvd_msg_id.
//
//  Upon receiving a message, the NXT will do a sanity check of the command
//  and data, and the msg ID.  If all okay, the reciving NXT will send an ACK
//  message of the form 0xc0mmmmid, where the id echos that of the message just
//  received.  The 4 data digits may be 0, or may answer a question posed in the
//  message.  If the receiving NXT has more data to return than will fit in
//  the 4 data digits, it will use ACK_STUB_WITH_CONTIUATION_1, and send back
//  2 ACK messages for the one command.
//
//  If the receiver thinks there is an error, it will send a NACK message of
//  the form 0xd0mmmmid, where the id echos that of the message just received.
//  The 4 data digits give some indication of the perceived error.
//
//  Protocol is that the LDR always sensds commands or questions.  The sprt
//  dancers always send an ACK or NACK.  When the sprt dancer needs to send
//  info to the LDR, it uses the 4 data digits in ACK response.  If there is
//  more data than can fit in 4 digits, then it uses the
//  ACK_STUB_WITH_CONTIUATION, starting at the highest number, such that the
//  last one sent is the plain ACK_STUB 0xc0000000.
//
#define  ACK_STUB                        0xc0000000
#define  ACK_STUB_WITH_CONTIUATION_1     0xc1000000
#define  ACK_STUB_WITH_CONTIUATION_2     0xc2000000
#define  ACK_STUB_WITH_CONTIUATION_3     0xc3000000
#define  ACK_STUB_WITH_CONTIUATION_F     0xcf000000
#define  NACK_STUB                       0xd0000000
#define  NACK_STUB_WITH_CONTIUATION_1    0xd1000000
#define  NACK_STUB_WITH_CONTIUATION_2    0xd2000000

#define ACK_NACK_MASK                    0xff000000  //  The ack, nack and command
#define COMMAND_MASK                     0xff000000  //  masks are currently equal,
                                                     //  but may not be in the future.
#define MSG_ID_MASK                      0x000000ff
#define QUEUE_MASK                       0x0000ff00
#define SPRT_REQUEST_MASK                0x00ff0000
#define DATA_DIGITS_MASK                 0x00ffff00

#define  RESEND_OFFSET                0x40000000
#define  CONTINUE_FROM_HERE_OFFSET    0x80000000

#define  IM_POLLING_U_STUB            0x11000000
#define  NEXT_QUEUE_TO_USE_STUB       0x12000000  //  0x22wwyyid, ww = bt_chan,
                                                  //  yy = next queue.
#define  UPDATE_STD_DELAY             0x14000000  //  For testing, or a new routine,
                                                  //  the LDR may send out new
                                                  //  updated std delays to the
                                                  //  sprts.  Or for different
                                                  //  types of do-it-now actions,
                                                  //  different delays may be
                                                  //  appropriate.

#define  PLAY_TONE_NOW_STUB           0x23000000  //  data is freq.
#define  BEGIN_LF_NOW_STUB            0x24000000  //  Do not ACK this, but begin
                                                  //  LF after your standard
                                                  //  delay, that allows all
                                                  //  other dancers to receive
                                                  //  this command.  LF == line
                                                  //  follow.
#define  DO_DANCE_STEP_NOW_STUB       0x25000000  //  Do not ACK this, but do
                                                  //  dnace step after your
                                                  //  standard delay, that allows
                                                  //  all other dancers to
                                                  //  receive this command.
                                                  //  data_digits are step.  If
                                                  //  data_digits == 0, then do
                                                  //  next dance step in your
                                                  //  routine.

#define  QUESTION_STUB                0x33000000
#define  END_AND_DISPLAY_STUB         0x3f000000  //  Stop BT comms, display
                                                  //  results.  Used for
                                                  //  debugging.

//  Data stubs
#define  MSG_ID_ERROR                 0x00c10000  //  To be used with NACK response.
#define  EXPECTED_MSG_TYPE_ERROR      0x00c20000  //  To be used with NACK response.  Sprt 

#define  WHERE_ARE_YOU                0x00200000  //  data for QUESTION_STUB
#define  MARKER_BLUE_01               0x00212100  //  responses for WHERE_ARE_YOU
#define  MARKER_BLUE_02               0x00212200
#define  MARKER_BLUE_03               0x00212300
#define  MARKER_RED_01                0x00215100
#define  IM_AAW_ALIB                  0x0021ee00  //  I'm alive and well and
                                                  //  living in Billund.

#define  I_NEED                       0x00310000
#define  WHAT_DO_YOU_NEED             0x00300000  //  data for QUESTION_STUB
#define  BRING_BLUE_BRICK             0x00322100  //  responses for DO_YOU_NEED
#define  BRING_GREEN_BRICK            0x00323100
#define  BRING_2X4_BRICK              0x00352400
#define  BRING_2X8_DUPLO              0x00372800
#define  BRING_COFFEE                 0x003e3100  //  i.e. fresh batteries.
#define  BRING_CHOCOLATE              0x003e3200

#define  BRING_LAWYERS                0x003ff100
#define  BRING_GUNS                   0x003ff200
#define  BRING_MONEY                  0x003ff300
#define  BRING_MORE_MONEY             0x003ff400


#define  IM_LOST_IN_RTNE              0x00410000  //  Dancer has lost place in
                                                  //  dance routine, and requesting
                                                  //  help from LDR.
#define  TWIRL_CW                     0x00411100
#define  TWIRL_CCW                    0x00411200


#endif  //  End of  -  #ifndef _TY_DNCR_BT_DEFINES_H

//  End of  -  File Ty_Dncr_31_BT_Defines.h

